#include "arc_ballMain.h"

ARC_BALL arcBall;

static float m_eyeZlocation;
static float translateSensitivity;
static float rotateFactor = 1.5;

// I crated the function AddTranslationDeltaTo_ObjectCenter() in the hope of altering the
// center of rotation (ie, vObjectCenterPtr) after the arc Ball alters the translation matrix.
// -------------------------------------------------------------------------------------
void AddTranslationDeltaTo_ObjectCenter(D3DXVECTOR3 *vObjectCenterPtr)  {
;  // what do I put here to adjust the center of rotation?
   // Or do I need a different arc ball function that has separate variables for
   // the center of rotation in the center of the objects?
}

/*
Unfortunately, I have not been able to figure out how to adjust the center of rotation
without altering the position of the objects. Here are two of my many failed attempts:

// -------------------------------------------------------------------------------------
void AddTranslationDeltaTo_ObjectCenter(D3DXVECTOR3 *vObjectCenterPtr)  {
// This block of code will keep the rotation center in the center of the screen.
// However, the objects do not rotate correctly unless you are in the top view;
// ie, looking down in the z axis, with Y axis running up and down, x axis running left and right.
// Otherwise, moving the mouse "upwards" on the screen will cause the objects to move
// along the positive y-axis even if the y-axis is pointing "down".
vObjectCenterPtr->x -= arcBall.mTranslationDelta._41;
vObjectCenterPtr->y -= arcBall.mTranslationDelta._42;

// compensate for moving the part by moving the eye location so that the part remains motionless
D3DXMatrixTranslation( &arcBall.mTranslationDelta, -arcBall.mTranslationDelta._41, -arcBall.mTranslationDelta._42, 0);
D3DXMatrixMultiply( &arcBall.mTranslation, &arcBall.mTranslation, &arcBall.mTranslationDelta );
}

// -------------------------------------------------------------------------------------
void AddTranslationDeltaTo_ObjectCenter(D3DXVECTOR3 *vObjectCenterPtr)  {
// the following doesn't work, either.
   D3DXMATRIXA16 translationDelta;
D3DXMatrixTranslation( &translationDelta, -arcBall.mTranslationDelta._41, -arcBall.mTranslationDelta._42, 0.0f );
D3DXMatrixMultiply( (D3DXMATRIX*)&translationDelta, (D3DXMATRIX*)&translationDelta, ArcBall_GetRotationMatrix() );
vObjectCenterPtr->x += translationDelta._41;
vObjectCenterPtr->y -= translationDelta._42;

D3DXMatrixTranslation( &translationDelta, translationDelta._41, -translationDelta._42, 0.0f );
D3DXMatrixMultiply( (D3DXMATRIX*)&translationDelta, (D3DXMATRIX*)&translationDelta, ArcBall_GetRotationMatrix() );
D3DXMatrixTranslation( &arcBall.mTranslationDelta, -arcBall.mTranslationDelta._41, -arcBall.mTranslationDelta._42, 0);
D3DXMatrixMultiply( &arcBall.mTranslation, &arcBall.mTranslation, &arcBall.mTranslationDelta );
}
*/

// --------------------------------------------------------------------------------------
void ArcBall_SetQuatNow( D3DXQUATERNION q ) {
arcBall.qNow = q;
}
// --------------------------------------------------------------------------------------
void ArcBall_Initialize (int dwBackBufferWidth, int dwBackBufferHeight, float fInScrollFactor, float eyeZlocation)  {

D3DXQuaternionIdentity( &arcBall.qDown );
D3DXQuaternionIdentity( &arcBall.qNow );
D3DXMatrixIdentity( &arcBall.mRotation );
D3DXMatrixIdentity( &arcBall.mTranslation );
D3DXMatrixIdentity( &arcBall.mTranslationDelta );

arcBall.winOffset.x = 0;
arcBall.winOffset.y = 0;
arcBall.actualWinUpperLeftOffset.x = 0;
arcBall.actualWinUpperLeftOffset.y = 0;
arcBall.actualWinLowerRightOffset.x = dwBackBufferWidth ;
arcBall.actualWinLowerRightOffset.y = dwBackBufferHeight ;

arcBall.winWidth = dwBackBufferWidth ;
arcBall.winHeight = dwBackBufferHeight ;
arcBall.scrollWheelFactor = fInScrollFactor;
arcBall.mTranslation._43 = eyeZlocation * -1.2f;      // dont let arcBall.mTranslation._43 become less than eyeZlocation
translateSensitivity  = arcBall.winWidth * (10.f/600.f);
m_eyeZlocation = eyeZlocation;
}
// --------------------------------------------------------------------------------------
static D3DXQUATERNION QuatFromBallPoints(const D3DXVECTOR3& vFrom, const D3DXVECTOR3& vTo ) {
    D3DXVECTOR3 vPart;
    float fDot = D3DXVec3Dot( &vFrom, &vTo );
D3DXVec3Cross( &vPart, &vFrom, &vTo );

return D3DXQUATERNION( vPart.x, vPart.y, vPart.z, fDot );
}
// --------------------------------------------------------------------------------------
static D3DXVECTOR3 ScreenToVector( float fScreenPtX, float fScreenPtY )  {
// Scale to screen
float x = -( fScreenPtX - arcBall.winOffset.x - arcBall.winWidth ) / ( arcBall.winWidth  );
float y = ( fScreenPtY - arcBall.winOffset.y - arcBall.winHeight ) / ( arcBall.winHeight );

float z = 0.0f;
float mag = x * x + y * y;

if( mag < 0.99999999f || mag > 1.00000001f )  {
   if( mag > 1.0f )
   {
       float scale = 1.0f / sqrtf( mag );
       x *= scale;
       y *= scale;
   }
   else
       z = sqrtf( 1.0f - mag );
}

return D3DXVECTOR3( x, y, z );     // Return vector
}


// --------------------------------------------------------------------------------------
D3DXMATRIX* ArcBall_GetRotationMatrix(void) {
return D3DXMatrixRotationQuaternion(&arcBall.mRotation, &arcBall.qNow);
}
// --------------------------------------------------------------------------------------
int ArcBall_HandleMouseEvents(int keypressed, POINT *mouseXY)  {
   // returns:   0: did nothing
   //            1: did something, redraw the screen
   //            2: changed object center, redraw the screen
   float fDeltaY;
   int numRolls;

if (keypressed == WM_LBUTTONDOWN || keypressed == WM_RBUTTONDOWN)  {
   // Only process the mouse clicks if user click in drawing window
   if( mouseXY->x > arcBall.actualWinUpperLeftOffset.x &&
       mouseXY->x < arcBall.actualWinLowerRightOffset.x &&
       mouseXY->y > arcBall.actualWinUpperLeftOffset.y &&
       mouseXY->y < arcBall.actualWinLowerRightOffset.y )
   {;}
   else  return 0;
}
switch( keypressed )  {
   case WM_LBUTTONDOWN:
      arcBall.buttonStatus = i_LEFT_M_BUTTON;
      arcBall.qDown = arcBall.qNow;
      arcBall.vDownPt = ScreenToVector( ( float )mouseXY->x * rotateFactor, ( float )mouseXY->y*rotateFactor);
      return 0;

   case WM_RBUTTONDOWN:
      arcBall.buttonStatus = i_RIGHT_M_BUTTON;
       // Store the position of the cursor when the button is pressed
       arcBall.ptLastMouse.x = mouseXY->x;
       arcBall.ptLastMouse.y = mouseXY->y;
       return 0;

   case WM_LBUTTONUP:
   case WM_RBUTTONUP:
      arcBall.buttonStatus = 0 ;
      return 0;

   case i_MOUSE_WHEEL_UP:
   case i_MOUSE_WHEEL_DOWN:
      numRolls = (keypressed == i_MOUSE_WHEEL_UP) ? 1 : -1;

      arcBall.buttonStatus = 0 ;   // just in case one of the buttons is still on, which seems to happen sometimes
      fDeltaY = (float)(arcBall.scrollWheelFactor * numRolls)  / (float)arcBall.winHeight;

      D3DXMatrixTranslation( &arcBall.mTranslationDelta, 0.0f, 0.0f, 5 * fDeltaY);
      D3DXMatrixMultiply( &arcBall.mTranslation, &arcBall.mTranslation, &arcBall.mTranslationDelta );
      return 1;

   case WM_MOUSEMOVE:
      if( arcBall.buttonStatus & i_LEFT_M_BUTTON)  {
         arcBall.vCurrentPt = ScreenToVector( ( float )mouseXY->x*rotateFactor, ( float )mouseXY->y*rotateFactor);
         arcBall.qNow = arcBall.qDown * QuatFromBallPoints( arcBall.vDownPt, arcBall.vCurrentPt );
         return 1;
      }

      if( arcBall.buttonStatus & i_RIGHT_M_BUTTON )  {
          // Normalize based on size of window and bounding sphere radius
          float fDeltaX = (float)(arcBall.ptLastMouse.x - mouseXY->x) * translateSensitivity / (float)arcBall.winWidth;
          fDeltaY = (float)(arcBall.ptLastMouse.y - mouseXY->y) * translateSensitivity / (float)arcBall.winHeight;

          // Store mouse coordinate
          arcBall.ptLastMouse.x = mouseXY->x;
          arcBall.ptLastMouse.y = mouseXY->y;

          D3DXMatrixTranslation( &arcBall.mTranslationDelta, -fDeltaX, fDeltaY, 0.0f );
          D3DXMatrixMultiply( &arcBall.mTranslation, &arcBall.mTranslation, &arcBall.mTranslationDelta );
          return 2;
      }
}
return 0;
}


