#include <d3dx9math.h>

#define  i_LEFT_M_BUTTON                     1
#define  i_CENTER_M_BUTTON                   4
#define  i_RIGHT_M_BUTTON                    2
#define  i_MOUSE_WHEEL_DOWN                 443
#define  i_MOUSE_WHEEL_UP                   444

typedef struct ArcBallStruct  {
   char buttonStatus;   // shows if a mouse button is down
   POINT actualWinUpperLeftOffset;   // upper-left corner of window for mouse presses
   POINT actualWinLowerRightOffset;   // this is the actual size of window as user sees it
   int winWidth;   // arc ball's window width - this is larger than the actual size
   int winHeight;  // arc ball's window height
   FLOAT scrollWheelFactor;
   POINT winOffset;   // window offset, or upper-left corner of window - this is larger than the actual size
   POINT ptLastMouse;      // position of last mouse point

   D3DXVECTOR3 vDownPt;           // starting point of rotation arc
   D3DXVECTOR3 vCurrentPt;        // current point of rotation arc

   D3DXMATRIXA16 mRotation;         // Matrix for arc ball's orientation
   D3DXMATRIXA16 mTranslation;      // Matrix for arc ball's position
   D3DXMATRIXA16 mTranslationDelta; // Matrix for arc ball's position
   D3DXQUATERNION qDown;             // Quaternion before button down
   D3DXQUATERNION qNow;              // Composite quaternion for current drag

} ARC_BALL;

void ArcBall_Initialize (int dwBackBufferWidth, int dwBackBufferHeight, float fInScrollFactor, float eyeZlocation) ;
void ArcBall_SetQuatNow( D3DXQUATERNION q );
D3DXMATRIX *ArcBall_GetRotationMatrix(void);
void ArcBall_ShiftViewpoint(float fDeltaX, float fDeltaY);
int ArcBall_HandleMouseEvents(int keypressed, POINT *mouseXY);

extern ARC_BALL arcBall;

